
[PATCH 4/6] Shrink-wrapping Click to flag this post

by Bernd Schmidt-4 Mar 23, 2011; 10:53pm :: Rate this Message: (use ratings to moderate[?])

Reply | Show Only this Message
This adds the actual optimization, and reworks the JUMP_LABEL handling
for return blocks. See the introduction mail or the new comment ahead of
thread_prologue_and_epilogue_insns for more notes.


Bernd

        * doc/tm.texi (RETURN_ADDR_REGNUM): Document.
        * doc/md.texi (simple_return): Document pattern.
        (return): Add a sentence to clarify.
        * doc/rtl.texi (simple_return): Document.
        * doc/invoke.texi (Optimize Options): Document -fshrink-wrap.
        * common.opt (fshrink-wrap): New.
        * opts.c (default_options_table): Enable it for -O1 and above.
        * gengenrtl.c (special_rtx): SIMPLE_RETURN is special.
        * rtl.h (ANY_RETURN_P): New macro.
        (global_rtl_index): Add GR_SIMPLE_RETURN.
        (simple_return_rtx): New macro.
        * genemit.c (gen_exp): SIMPLE_RETURN has a unique rtx.
        (gen_expand, gen_split): Use ANY_RETURN_P.
        * rtl.c (copy_rtx): SIMPLE_RETURN is shared.
        * emit-rtl.c (verify_rtx_sharing): Likewise.
        (skip_consecutive_labels): Return the argument if it is a return rtx.
        (classify_insn): Handle both kinds of return.
        (init_emit_regs): Create global rtl for ret_rtx and simple_return_rtx.
        * df-scan.c (df_uses_record): Handle SIMPLE_RETURN.
        * rtl.def (SIMPLE_RETURN): New.
        * rtlanal.c (tablejump_p): Check JUMP_LABEL for returns.
        * final.c (final_scan_insn): Recognize both kinds of return.
        * reorg.c (function_return_label, function_simple_return_label): New
        static variables.
        (end_of_function_label): Remove.
        (simplejump_or_return_p): New static function.
        (find_end_label): Add a new arg, KIND.  All callers changed.
        Depending on KIND, look for a label suitable for return or
        simple_return.
        (make_return_insns): Make corresponding changes.
        (get_jump_flags): Check JUMP_LABELs for returns.
        (follow_jumps): Likewise.
        (get_branch_condition): Check target for return patterns rather
        than NULL.
        (own_thread_p): Likewise for thread.
        (steal_delay_list_from_target): Check JUMP_LABELs for returns.
        Use simplejump_or_return_p.
        (fill_simple_delay_slots): Likewise.
        (optimize_skip): Likewise.
        (fill_slots_from_thread): Likewise.
        (relax_delay_slots): Likewise.
        (dbr_schedule): Adjust handling of end_of_function_label for the
        two new variables.
        * ifcvt.c (find_if_case_1): Take care when redirecting jumps to the
        exit block.
        (dead_or_predicable): Change NEW_DEST arg to DEST_EDGE.  All callers
        changed.  Ensure that the right label is passed to redirect_jump.
        * jump.c (condjump_p, condjump_in_parallel_p, any_condjump_p,
        returnjump_p): Handle SIMPLE_RETURNs.
        (delete_related_insns): Check JUMP_LABEL for returns.
        (redirect_target): New static function.
        (redirect_exp_1): Use it.  Handle any kind of return rtx as a label
        rather than interpreting NULL as a return.
        (redirect_jump_1): Assert that nlabel is not NULL.
        (redirect_jump): Likewise.
        (redirect_jump_2): Handle any kind of return rtx as a label rather
        than interpreting NULL as a return.
        * dwarf2out.c (compute_barrier_args_size_1): Check JUMP_LABEL for
        returns.
        * function.c (emit_return_into_block): Remove useless declaration.
        (record_hard_reg_sets, frame_required_for_rtx, gen_return_pattern,
        requires_stack_frame_p): New static functions.
        (emit_return_into_block): New arg SIMPLE_P.  All callers changed.
        Generate either kind of return pattern and update the JUMP_LABEL.
        (thread_prologue_and_epilogue_insns): Implement a form of
        shrink-wrapping.  Ensure JUMP_LABELs for return insns are set.
        * print-rtl.c (print_rtx): Handle returns in JUMP_LABELs.
        * cfglayout.c (fixup_reorder_chain): Ensure JUMP_LABELs for returns
        remain correct.
        * resource.c (find_dead_or_set_registers): Check JUMP_LABELs for
        returns.
        (mark_target_live_regs): Don't pass a return rtx to next_active_insn.
        * basic-block.h (force_nonfallthru_and_redirect): Declare.
        * sched-vis.c (print_pattern): Add case for SIMPLE_RETURN.
        * cfgrtl.c (force_nonfallthru_and_redirect): No longer static.  New arg
        JUMP_LABEL.  All callers changed.  Use the label when generating
        return insns.

        * config/i386/i386.md (returns, return_str, return_cond): New
        code_iterator and corresponding code_attrs.
        (<return_str>return): Renamed from return and adapted.
        (<return_str>return_internal): Likewise for return_internal.
        (<return_str>return_internal_long): Likewise for return_internal_long.
        (<return_str>return_pop_internal): Likewise for return_pop_internal.
        (<return_str>return_indirect_internal): Likewise for
        return_indirect_internal.
        * config/i386/i386.c (ix86_expand_epilogue): Expand a simple_return as
        the last insn.
        (ix86_pad_returns): Handle both kinds of return rtx.
        * config/arm/arm.c (use_simple_return_p): new function.
        (is_jump_table): Handle returns in JUMP_LABELs.
        (output_return_instruction): New arg SIMPLE.  All callers changed.
        Use it to determine which kind of return to generate.
        (arm_final_prescan_insn): Handle both kinds of return.
        * config/arm/arm.md (returns, return_str, return_simple_p,
        return_cond): New code_iterator and corresponding code_attrs.
        (<return_str>return): Renamed from return and adapted.
        (arm_<return_str>return): Renamed from arm_return and adapted.
        (cond_<return_str>return): Renamed from cond_return and adapted.
        (cond_<return_str>return_inverted): Renamed from cond_return_inverted
        and adapted.
        * config/arm/thumb2.md (thumb2_<return_str>return): Renamed from
        thumb2_return and adapted.
        * config/arm/arm.h (RETURN_ADDR_REGNUM): Define.
        * config/arm/arm-protos.h (use_simple_return_p): Declare.
        (output_return_instruction): Adjust declaration.
        * config/mips/mips.c (mips_expand_epilogue): Generate a simple_return
        as final insn.
        * config/mips/mips.md (simple_return): New expander.
        (*simple_return, simple_return_internal): New patterns.
        * config/sh/sh.c (barrier_align): Handle return in a JUMP_LABEL.
        (split_branches): Don't pass a null label to redirect_jump.

Index: gcc/basic-block.h
===================================================================
--- gcc.orig/basic-block.h
+++ gcc/basic-block.h
@@ -795,6 +795,7 @@ extern void flow_edge_list_print (const
 
 /* In cfgrtl.c  */
 extern basic_block force_nonfallthru (edge);
+extern basic_block force_nonfallthru_and_redirect (edge, basic_block, rtx);
 extern rtx block_label (basic_block);
 extern bool purge_all_dead_edges (void);
 extern bool purge_dead_edges (basic_block);
Index: gcc/cfglayout.c
===================================================================
--- gcc.orig/cfglayout.c
+++ gcc/cfglayout.c
@@ -766,6 +766,7 @@ fixup_reorder_chain (void)
     {
       edge e_fall, e_taken, e;
       rtx bb_end_insn;
+      rtx ret_label = NULL_RTX;
       basic_block nb;
       edge_iterator ei;
 
@@ -785,6 +786,7 @@ fixup_reorder_chain (void)
       bb_end_insn = BB_END (bb);
       if (JUMP_P (bb_end_insn))
  {
+  ret_label = JUMP_LABEL (bb_end_insn);
   if (any_condjump_p (bb_end_insn))
     {
       /* This might happen if the conditional jump has side
@@ -895,7 +897,7 @@ fixup_reorder_chain (void)
  }
 
       /* We got here if we need to add a new jump insn.  */
-      nb = force_nonfallthru (e_fall);
+      nb = force_nonfallthru_and_redirect (e_fall, e_fall->dest, ret_label);
       if (nb)
  {
   nb->il.rtl->visited = 1;
@@ -1129,24 +1131,30 @@ extern bool cfg_layout_can_duplicate_bb_
 bool
 cfg_layout_can_duplicate_bb_p (const_basic_block bb)
 {
+  rtx insn;
+
   /* Do not attempt to duplicate tablejumps, as we need to unshare
      the dispatch table.  This is difficult to do, as the instructions
      computing jump destination may be hoisted outside the basic block.  */
   if (tablejump_p (BB_END (bb), NULL, NULL))
     return false;
 
-  /* Do not duplicate blocks containing insns that can't be copied.  */
-  if (targetm.cannot_copy_insn_p)
+  insn = BB_HEAD (bb);
+  while (1)
     {
-      rtx insn = BB_HEAD (bb);
-      while (1)
- {
-  if (INSN_P (insn) && targetm.cannot_copy_insn_p (insn))
-    return false;
-  if (insn == BB_END (bb))
-    break;
-  insn = NEXT_INSN (insn);
- }
+      /* Do not duplicate blocks containing insns that can't be copied.  */
+      if (INSN_P (insn) && targetm.cannot_copy_insn_p
+  && targetm.cannot_copy_insn_p (insn))
+ return false;
+      /* dwarf2out expects that these notes are always paired with a
+ returnjump or sibling call.  */
+      if (NOTE_P (insn) && NOTE_KIND (insn) == NOTE_INSN_EPILOGUE_BEG
+  && !returnjump_p (BB_END (bb))
+  && (!CALL_P (BB_END (bb)) || !SIBLING_CALL_P (BB_END (bb))))
+ return false;
+      if (insn == BB_END (bb))
+ break;
+      insn = NEXT_INSN (insn);
     }
 
   return true;
@@ -1191,6 +1199,9 @@ duplicate_insn_chain (rtx from, rtx to)
       break;
     }
   copy = emit_copy_of_insn_after (insn, get_last_insn ());
+  if (JUMP_P (insn) && JUMP_LABEL (insn) != NULL_RTX
+      && ANY_RETURN_P (JUMP_LABEL (insn)))
+    JUMP_LABEL (copy) = JUMP_LABEL (insn);
           maybe_copy_prologue_epilogue_insn (insn, copy);
   break;
 
Index: gcc/cfgrtl.c
===================================================================
--- gcc.orig/cfgrtl.c
+++ gcc/cfgrtl.c
@@ -1114,10 +1114,13 @@ rtl_redirect_edge_and_branch (edge e, ba
 }
 
 /* Like force_nonfallthru below, but additionally performs redirection
-   Used by redirect_edge_and_branch_force.  */
+   Used by redirect_edge_and_branch_force.  JUMP_LABEL is used only
+   when redirecting to the EXIT_BLOCK, it is either a return or a
+   simple_return rtx indicating which kind of returnjump to create.
+   It should be NULL otherwise.  */
 
-static basic_block
-force_nonfallthru_and_redirect (edge e, basic_block target)
+basic_block
+force_nonfallthru_and_redirect (edge e, basic_block target, rtx jump_label)
 {
   basic_block jump_block, new_bb = NULL, src = e->src;
   rtx note;
@@ -1249,11 +1252,25 @@ force_nonfallthru_and_redirect (edge e,
   e->flags &= ~EDGE_FALLTHRU;
   if (target == EXIT_BLOCK_PTR)
     {
+      if (jump_label == ret_rtx)
+ {
 #ifdef HAVE_return
- emit_jump_insn_after_setloc (gen_return (), BB_END (jump_block), loc);
+  emit_jump_insn_after_setloc (gen_return (), BB_END (jump_block),
+       loc);
 #else
- gcc_unreachable ();
+  gcc_unreachable ();
 #endif
+ }
+      else
+ {
+  gcc_assert (jump_label == simple_return_rtx);
+#ifdef HAVE_simple_return
+  emit_jump_insn_after_setloc (gen_simple_return (),
+       BB_END (jump_block), loc);
+#else
+  gcc_unreachable ();
+#endif
+ }
     }
   else
     {
@@ -1280,7 +1297,7 @@ force_nonfallthru_and_redirect (edge e,
 basic_block
 force_nonfallthru (edge e)
 {
-  return force_nonfallthru_and_redirect (e, e->dest);
+  return force_nonfallthru_and_redirect (e, e->dest, NULL_RTX);
 }
 
 /* Redirect edge even at the expense of creating new jump insn or
@@ -1297,7 +1314,7 @@ rtl_redirect_edge_and_branch_force (edge
   /* In case the edge redirection failed, try to force it to be non-fallthru
      and redirect newly created simplejump.  */
   df_set_bb_dirty (e->src);
-  return force_nonfallthru_and_redirect (e, target);
+  return force_nonfallthru_and_redirect (e, target, NULL_RTX);
 }
 
 /* The given edge should potentially be a fallthru edge.  If that is in
Index: gcc/config/arm/arm-protos.h
===================================================================
--- gcc.orig/config/arm/arm-protos.h
+++ gcc/config/arm/arm-protos.h
@@ -24,6 +24,7 @@
 #define GCC_ARM_PROTOS_H
 
 extern int use_return_insn (int, rtx);
+extern bool use_simple_return_p (void);
 extern enum reg_class arm_regno_class (int);
 extern void arm_load_pic_register (unsigned long);
 extern int arm_volatile_func (void);
@@ -135,7 +136,7 @@ extern int arm_address_offset_is_imm (rt
 extern const char *output_add_immediate (rtx *);
 extern const char *arithmetic_instr (rtx, int);
 extern void output_ascii_pseudo_op (FILE *, const unsigned char *, int);
-extern const char *output_return_instruction (rtx, int, int);
+extern const char *output_return_instruction (rtx, bool, bool, bool);
 extern void arm_poke_function_name (FILE *, const char *);
 extern void arm_final_prescan_insn (rtx);
 extern int arm_debugger_arg_offset (int, rtx);
Index: gcc/config/arm/arm.c
===================================================================
--- gcc.orig/config/arm/arm.c
+++ gcc/config/arm/arm.c
@@ -2252,6 +2252,18 @@ arm_trampoline_adjust_address (rtx addr)
   return addr;
 }
 
+/* Return true if we should try to use a simple_return insn, i.e. perform
+   shrink-wrapping if possible.  This is the case if we need to emit a
+   prologue, which we can test by looking at the offsets.  */
+bool
+use_simple_return_p (void)
+{
+  arm_stack_offsets *offsets;
+
+  offsets = arm_get_frame_offsets ();
+  return offsets->outgoing_args != 0;
+}
+
 /* Return 1 if it is possible to return using a single instruction.
    If SIBLING is non-null, this is a test for a return before a sibling
    call.  SIBLING is the call insn, so we can examine its register usage.  */
@@ -11388,6 +11400,7 @@ is_jump_table (rtx insn)
 
   if (GET_CODE (insn) == JUMP_INSN
       && JUMP_LABEL (insn) != NULL
+      && !ANY_RETURN_P (JUMP_LABEL (insn))
       && ((table = next_real_insn (JUMP_LABEL (insn)))
   == next_real_insn (insn))
       && table != NULL
@@ -14234,7 +14247,7 @@ arm_get_vfp_saved_size (void)
 /* Generate a function exit sequence.  If REALLY_RETURN is false, then do
    everything bar the final return instruction.  */
 const char *
-output_return_instruction (rtx operand, int really_return, int reverse)
+output_return_instruction (rtx operand, bool really_return, bool reverse, bool simple)
 {
   char conditional[10];
   char instr[100];
@@ -14272,10 +14285,15 @@ output_return_instruction (rtx operand,
 
   sprintf (conditional, "%%?%%%c0", reverse ? 'D' : 'd');
 
-  cfun->machine->return_used_this_function = 1;
+  if (simple)
+    live_regs_mask = 0;
+  else
+    {
+      cfun->machine->return_used_this_function = 1;
 
-  offsets = arm_get_frame_offsets ();
-  live_regs_mask = offsets->saved_regs_mask;
+      offsets = arm_get_frame_offsets ();
+      live_regs_mask = offsets->saved_regs_mask;
+    }
 
   if (live_regs_mask)
     {
@@ -17283,6 +17301,7 @@ arm_final_prescan_insn (rtx insn)
 
   /* If we start with a return insn, we only succeed if we find another one.  */
   int seeking_return = 0;
+  enum rtx_code return_code = UNKNOWN;
 
   /* START_INSN will hold the insn from where we start looking.  This is the
      first insn after the following code_label if REVERSE is true.  */
@@ -17321,7 +17340,7 @@ arm_final_prescan_insn (rtx insn)
   else
     return;
  }
-      else if (GET_CODE (body) == RETURN)
+      else if (ANY_RETURN_P (body))
         {
   start_insn = next_nonnote_insn (start_insn);
   if (GET_CODE (start_insn) == BARRIER)
@@ -17332,6 +17351,7 @@ arm_final_prescan_insn (rtx insn)
     {
       reverse = TRUE;
       seeking_return = 1;
+      return_code = GET_CODE (body);
     }
   else
     return;
@@ -17372,11 +17392,15 @@ arm_final_prescan_insn (rtx insn)
   label = XEXP (XEXP (SET_SRC (body), 2), 0);
   then_not_else = FALSE;
  }
-      else if (GET_CODE (XEXP (SET_SRC (body), 1)) == RETURN)
- seeking_return = 1;
-      else if (GET_CODE (XEXP (SET_SRC (body), 2)) == RETURN)
+      else if (ANY_RETURN_P (XEXP (SET_SRC (body), 1)))
+ {
+  seeking_return = 1;
+  return_code = GET_CODE (XEXP (SET_SRC (body), 1));
+ }
+      else if (ANY_RETURN_P (XEXP (SET_SRC (body), 2)))
         {
   seeking_return = 1;
+  return_code = GET_CODE (XEXP (SET_SRC (body), 2));
   then_not_else = FALSE;
         }
       else
@@ -17477,8 +17501,7 @@ arm_final_prescan_insn (rtx insn)
        && !use_return_insn (TRUE, NULL)
        && !optimize_size)
  fail = TRUE;
-      else if (GET_CODE (scanbody) == RETURN
-       && seeking_return)
+      else if (GET_CODE (scanbody) == return_code)
         {
   arm_ccfsm_state = 2;
   succeed = TRUE;
Index: gcc/config/arm/arm.h
===================================================================
--- gcc.orig/config/arm/arm.h
+++ gcc/config/arm/arm.h
@@ -2255,6 +2255,8 @@ extern int making_const_table;
 #define RETURN_ADDR_RTX(COUNT, FRAME) \
   arm_return_addr (COUNT, FRAME)
 
+#define RETURN_ADDR_REGNUM LR_REGNUM
+
 /* Mask of the bits in the PC that contain the real return address
    when running in 26-bit mode.  */
 #define RETURN_ADDR_MASK26 (0x03fffffc)
Index: gcc/config/i386/i386.c
===================================================================
--- gcc.orig/config/i386/i386.c
+++ gcc/config/i386/i386.c
@@ -11230,13 +11230,13 @@ ix86_expand_epilogue (int style)
 
   pro_epilogue_adjust_stack (stack_pointer_rtx, stack_pointer_rtx,
      popc, -1, true);
-  emit_jump_insn (gen_return_indirect_internal (ecx));
+  emit_jump_insn (gen_simple_return_indirect_internal (ecx));
  }
       else
- emit_jump_insn (gen_return_pop_internal (popc));
+ emit_jump_insn (gen_simple_return_pop_internal (popc));
     }
   else
-    emit_jump_insn (gen_return_internal ());
+    emit_jump_insn (gen_simple_return_internal ());
 
   /* Restore the state back to the state from the prologue,
      so that it's correct for the next epilogue.  */
@@ -30176,7 +30176,7 @@ ix86_pad_returns (void)
       rtx prev;
       bool replace = false;
 
-      if (!JUMP_P (ret) || GET_CODE (PATTERN (ret)) != RETURN
+      if (!JUMP_P (ret) || !ANY_RETURN_P (PATTERN (ret))
   || optimize_bb_for_size_p (bb))
  continue;
       for (prev = PREV_INSN (ret); prev; prev = PREV_INSN (prev))
@@ -30206,7 +30206,10 @@ ix86_pad_returns (void)
  }
       if (replace)
  {
-  emit_jump_insn_before (gen_return_internal_long (), ret);
+  if (PATTERN (ret) == ret_rtx)
+    emit_jump_insn_before (gen_return_internal_long (), ret);
+  else
+    emit_jump_insn_before (gen_simple_return_internal_long (), ret);
   delete_insn (ret);
  }
     }
@@ -30227,7 +30230,7 @@ ix86_count_insn_bb (basic_block bb)
     {
       /* Only happen in exit blocks.  */
       if (JUMP_P (insn)
-  && GET_CODE (PATTERN (insn)) == RETURN)
+  && ANY_RETURN_P (PATTERN (insn)))
  break;
 
       if (NONDEBUG_INSN_P (insn)
@@ -30300,7 +30303,7 @@ ix86_pad_short_function (void)
   FOR_EACH_EDGE (e, ei, EXIT_BLOCK_PTR->preds)
     {
       rtx ret = BB_END (e->src);
-      if (JUMP_P (ret) && GET_CODE (PATTERN (ret)) == RETURN)
+      if (JUMP_P (ret) && ANY_RETURN_P (PATTERN (ret)))
  {
   int insn_count = ix86_count_insn (e->src);
 
Index: gcc/config/mips/mips.c
===================================================================
--- gcc.orig/config/mips/mips.c
+++ gcc/config/mips/mips.c
@@ -10543,7 +10543,8 @@ mips_expand_epilogue (bool sibcall_p)
     regno = GP_REG_FIRST + 7;
   else
     regno = RETURN_ADDR_REGNUM;
-  emit_jump_insn (gen_return_internal (gen_rtx_REG (Pmode, regno)));
+  emit_jump_insn (gen_simple_return_internal (gen_rtx_REG (Pmode,
+   regno)));
  }
     }
 
Index: gcc/config/sh/sh.c
===================================================================
--- gcc.orig/config/sh/sh.c
+++ gcc/config/sh/sh.c
@@ -5455,7 +5455,8 @@ barrier_align (rtx barrier_or_label)
  }
       if (prev
   && JUMP_P (prev)
-  && JUMP_LABEL (prev))
+  && JUMP_LABEL (prev)
+  && !ANY_RETURN_P (JUMP_LABEL (prev)))
  {
   rtx x;
   if (jump_to_next
@@ -6154,7 +6155,7 @@ split_branches (rtx first)
  JUMP_LABEL (insn) = far_label;
  LABEL_NUSES (far_label)++;
       }
-    redirect_jump (insn, NULL_RTX, 1);
+    redirect_jump (insn, ret_rtx, 1);
     far_label = 0;
   }
       }
Index: gcc/config/sparc/sparc.c
===================================================================
--- gcc.orig/config/sparc/sparc.c
+++ gcc/config/sparc/sparc.c
@@ -6105,7 +6105,7 @@ sparc_struct_value_rtx (tree fndecl, int
   /* We must check and adjust the return address, as it is
      optional as to whether the return object is really
      provided.  */
-  rtx ret_rtx = gen_rtx_REG (Pmode, 31);
+  rtx ret_reg = gen_rtx_REG (Pmode, 31);
   rtx scratch = gen_reg_rtx (SImode);
   rtx endlab = gen_label_rtx ();
 
@@ -6122,12 +6122,12 @@ sparc_struct_value_rtx (tree fndecl, int
      it's an unimp instruction (the most significant 10 bits
      will be zero).  */
   emit_move_insn (scratch, gen_rtx_MEM (SImode,
- plus_constant (ret_rtx, 8)));
+ plus_constant (ret_reg, 8)));
   /* Assume the size is valid and pre-adjust */
-  emit_insn (gen_add3_insn (ret_rtx, ret_rtx, GEN_INT (4)));
+  emit_insn (gen_add3_insn (ret_reg, ret_reg, GEN_INT (4)));
   emit_cmp_and_jump_insns (scratch, size_rtx, EQ, const0_rtx, SImode,
    0, endlab);
-  emit_insn (gen_sub3_insn (ret_rtx, ret_rtx, GEN_INT (4)));
+  emit_insn (gen_sub3_insn (ret_reg, ret_reg, GEN_INT (4)));
   /* Write the address of the memory pointed to by temp_val into
      the memory pointed to by mem */
   emit_move_insn (mem, XEXP (temp_val, 0));
Index: gcc/df-scan.c
===================================================================
--- gcc.orig/df-scan.c
+++ gcc/df-scan.c
@@ -3181,6 +3181,7 @@ df_uses_record (struct df_collection_rec
       }
 
     case RETURN:
+    case SIMPLE_RETURN:
       break;
 
     case ASM_OPERANDS:
Index: gcc/doc/tm.texi.in
===================================================================
--- gcc.orig/doc/tm.texi.in
+++ gcc/doc/tm.texi.in
@@ -3198,6 +3198,12 @@ Define this if the return address of a p
 from the frame pointer of the previous stack frame.
 @end defmac
 
+@defmac RETURN_ADDR_REGNUM
+If defined, a C expression whose value is the register number of the return
+address for the current function.  Targets that pass the return address on
+the stack should not define this macro.
+@end defmac
+
 @defmac INCOMING_RETURN_ADDR_RTX
 A C expression whose value is RTL representing the location of the
 incoming return address at the beginning of any function, before the
Index: gcc/dwarf2out.c
===================================================================
--- gcc.orig/dwarf2out.c
+++ gcc/dwarf2out.c
@@ -1490,7 +1490,7 @@ compute_barrier_args_size_1 (rtx insn, H
     {
       rtx dest = JUMP_LABEL (insn);
 
-      if (dest)
+      if (dest && !ANY_RETURN_P (dest))
  {
   if (barrier_args_size [INSN_UID (dest)] < 0)
     {
Index: gcc/emit-rtl.c
===================================================================
--- gcc.orig/emit-rtl.c
+++ gcc/emit-rtl.c
@@ -2448,6 +2448,7 @@ verify_rtx_sharing (rtx orig, rtx insn)
     case PC:
     case CC0:
     case RETURN:
+    case SIMPLE_RETURN:
     case SCRATCH:
       return;
       /* SCRATCH must be shared because they represent distinct values.  */
@@ -3252,14 +3253,17 @@ prev_label (rtx insn)
   return insn;
 }
 
-/* Return the last label to mark the same position as LABEL.  Return null
-   if LABEL itself is null.  */
+/* Return the last label to mark the same position as LABEL.  Return LABEL
+   itself if it is null or any return rtx.  */
 
 rtx
 skip_consecutive_labels (rtx label)
 {
   rtx insn;
 
+  if (label && ANY_RETURN_P (label))
+    return label;
+
   for (insn = label; insn != 0 && !INSN_P (insn); insn = NEXT_INSN (insn))
     if (LABEL_P (insn))
       label = insn;
@@ -5145,7 +5149,7 @@ classify_insn (rtx x)
     return CODE_LABEL;
   if (GET_CODE (x) == CALL)
     return CALL_INSN;
-  if (GET_CODE (x) == RETURN)
+  if (GET_CODE (x) == RETURN || GET_CODE (x) == SIMPLE_RETURN)
     return JUMP_INSN;
   if (GET_CODE (x) == SET)
     {
@@ -5654,6 +5658,7 @@ init_emit_regs (void)
   /* Assign register numbers to the globally defined register rtx.  */
   pc_rtx = gen_rtx_fmt_ (PC, VOIDmode);
   ret_rtx = gen_rtx_fmt_ (RETURN, VOIDmode);
+  simple_return_rtx = gen_rtx_fmt_ (SIMPLE_RETURN, VOIDmode);
   cc0_rtx = gen_rtx_fmt_ (CC0, VOIDmode);
   stack_pointer_rtx = gen_raw_REG (Pmode, STACK_POINTER_REGNUM);
   frame_pointer_rtx = gen_raw_REG (Pmode, FRAME_POINTER_REGNUM);
Index: gcc/final.c
===================================================================
--- gcc.orig/final.c
+++ gcc/final.c
@@ -2425,7 +2425,8 @@ final_scan_insn (rtx insn, FILE *file, i
         delete_insn (insn);
  break;
       }
-    else if (GET_CODE (SET_SRC (body)) == RETURN)
+    else if (GET_CODE (SET_SRC (body)) == RETURN
+     || GET_CODE (SET_SRC (body)) == SIMPLE_RETURN)
       /* Replace (set (pc) (return)) with (return).  */
       PATTERN (insn) = body = SET_SRC (body);
 
